#include <iostream>
#include "../../snap/Snap.h"

using namespace std;

int main(int argc, char* argv[]) {
	TIntH expCount, PoissonCount;
	TRnd a;
	double binSize=0.1;
	//exponential distribution	
	for (int i=0; i<10000; ++i)
	{
		double num=a.GetExpDev(1);
		expCount.AddDat((int)(num/binSize))++;
	}

	//Poisson distribution	
	for (int i=0; i<10000; ++i)
	{
		double num=a.GetPoissonDev(10);
		PoissonCount.AddDat((int)(num/binSize))++;
	}


	expCount.Sort(true,true);
	PoissonCount.Sort(true,true);

	{
		TVec<TPair<TFlt, TFlt > > XY1, XY2;
		for (int i=0; i<expCount.Len(); ++i)
			XY1.Add(TFltPr(expCount.GetKey(i)*binSize, expCount[i]+0.0));
		for (int i=0; i<PoissonCount.Len(); ++i)
			XY2.Add(TFltPr(PoissonCount.GetKey(i)*binSize, PoissonCount[i]+0.0));
		TGnuPlot Gp("distribution", "Exponential and Poisson Distribution");
		Gp.AddPlot(XY1, gpwLinesPoints, "Exponential");
		Gp.AddPlot(XY2, gpwLinesPoints, "Poisson");
		Gp.SetXYLabel("value", "count");
		Gp.SavePng(); //or Gp.SaveEps();
	}

    return 0;
}
