#include "stdafx.h"

//Example for using Tmom
int main(int argc, char* argv[]) {
  TMom mom;

  for (int i=0; i<100; ++i)
  {
	// create some graph based on a parameter
	PUNGraph G = TSnap::GenRndGnm<PUNGraph>(1000,1000);
	mom.Add(TSnap::GetMxWcc<PUNGraph>(G)->GetNodes());
  }
  mom.Def(); //tell Tmom that no more data will be added
  printf("Mean=%.2lf  Standard deviation=%.2lf  Median=%.2lf\n", mom.GetMean(), mom.GetSDev(), mom.GetMedian());

  TFltV a, b;
  for (int i=0; i<100; ++i)
  {
	a.Add(i+0.0);
	b.Add(-i+0.0);
  }
  TCorr corr(a,b);
  printf("correlation coefficient 1 is %.6lf\n",  corr.GetCorrCf());

  TFltV c, d;
  for (int i=0; i<100; ++i)
  {
	c.Add(i+0.0);
	d.Add(i*2+0.0);
  }
  TCorr corr2(c,d);
  printf("correlation coefficient 2 is %.6lf\n",  corr2.GetCorrCf());
  return 0;
}
